Whamcloud - gitweb
LU-5306: Update download and other whamcloud URLs
[fs/lustre-release.git] / contrib / lbuild / lbuild
1 #!/bin/bash
2
3 # vim:expandtab:shiftwidth=4:softtabstop=4:tabstop=4:
4
5 # this is an alternative FD for stdout, to be used especially when we are
6 # taking stdout from a function as it's return value.  i.e. foo=$(bar)
7 # this is a workaround until a version of bash where we can put xtrace
8 # on a specific FD
9 exec 3>&1; STDOUT=3
10
11 #set -x
12 xtrace="+x"
13 if [[ $SHELLOPTS = *xtrace* ]]; then
14     xtrace="-x"
15 fi
16 shopt -s extdebug
17
18 # Assume that lbuild's support files can be found in the same
19 # canonicalized path as this very script.
20 LBUILD_SCRIPT=$(readlink -f ${0})
21 LBUILD_DIR=${LBUILD_DIR:-$(dirname ${LBUILD_SCRIPT})}
22
23 # include the exit_traps library
24 . ${LBUILD_DIR}/exit_traps.sh
25 . ${LBUILD_DIR}/funcs.sh
26
27 # our children should die when we do
28 push_exit_trap "kill -INT -$$ || true" kill_children
29
30 # increment this if you have made a change that should force a new kernel
31 # to build built
32 #BUILD_GEN=1
33 #BUILD_GEN=2    # bz19952: remove -lustre tag from kernel RPM names
34 #BUILD_GEN=3    # bz19975: enable the building of src.rpms by default
35 #BUILD_GEN=4    # bz22281: use the git hash in the kernel extra version
36 #BUILD_GEN=5    # TT-107: don't cache the BUILD dir
37 BUILD_GEN=6     # TT-1092: don't cache the BUILD dir, to rebuild external OFED
38
39 TOPDIR=$PWD
40
41 KERNELDIR=
42 LINUX=
43 LUSTRE=
44 RELEASE=false
45 # XXX - some recent hacking has pretty much neutered this option.
46 #       search through this file for "-bb" and see how many places
47 #       simply don't account for this option
48 DO_SRC=true
49 DOWNLOAD=true
50 CANONICAL_TARGET=
51 TARGET=
52 TARGET_ARCH="$(uname -m)"
53 # change default behavior to only build for the current arch
54 TARGET_ARCHS="$TARGET_ARCH"
55 TARGET_ARCHS_ALL="$TARGET_ARCH"
56 [ "$TARGET_ARCH" = "i686" ] && TARGET_ARCHS_ALL="i686 i586 i386"
57 CONFIGURE_FLAGS=
58 EXTERNAL_PATCHES=
59 EXTRA_VERSION=
60 STAGEDIR=
61 TMPDIR=${TMPDIR:-"/var/tmp"}
62 TIMESTAMP=
63 # this is the dir that should be used to store reuse products
64 REUSEBUILD=
65 # should cached products be used or force rebuilding?
66 USE_BUILD_CACHE=true
67 # what does this do exactly?  does it imply no kernel build?
68 NORPM=false
69 IOKITRPM=true
70 OSDLDISKFSRPM=true
71 OSDZFSRPM=false
72 SMPTYPES="smp bigsmp default ''"
73 PATCHLESS=false
74 XEN=false
75 LINUXOBJ=
76 DISTRO=
77 KERNELTREE=
78 # default to not adding -lustre- into the kernel RPM package names
79 KERNEL_LUSTRE_NAMING=false
80 # default not use kabi check.
81 USE_KABI=false
82
83 # patchless build
84 KERNELRPMSBASE=
85 RPMSMPTYPE=
86
87 # from target file
88 SERIES=
89 BASE_ARCHS=
90 BIGMEM_ARCHS=
91 BOOT_ARCHS=
92 JENSEN_ARCHS=
93 SMP_ARCHS=
94 BIGSMP_ARCHS=
95 PSERIES64_ARCHS=
96 UP_ARCHS=
97
98 # not in the target file any more
99 CONFIG=
100
101 # build the lustre-tests rpm?
102 LUSTRE_TESTS=true
103
104 DATE=$(date)
105
106 RPMBUILD=
107
108 export CC=${CC:-gcc}
109
110 # Readlink is not present on some older distributions: emulate it.
111 readlink() {
112     local path=$1 ll
113
114     if [ -L "$path" ]; then
115         ll="$(LC_ALL=C ls -l "$path" 2> /dev/null)" &&
116         echo "${ll/* -> }"
117     else
118         return 1
119     fi
120 }
121
122 usage() {
123     cat <<EOF
124 Usage: ${0##*/} [OPTION]... [-- <lustre configure options>]
125
126   --external-patches=EXTERNAL_PATCHES
127     Directory similar to lustre/lustre/kernel_patches/ that lbuild should
128     look for seres and config files in before looking in the lustre
129     tree.
130
131   --extraversion=EXTRAVERSION
132     Text to use for the rpm release and kernel extraversion.
133
134   --timestamp=TIMESTAMP
135     Date of building lustre in format YYYYMMDDhhmmss
136
137   --reusebuild=DIR
138     Try to reuse old kernel builds from DIR
139
140   --kernelrpm=DIR
141     Path to distro kernel RPM collection
142
143   --ccache
144     Use ccache
145
146   --norpm
147     Do not build RPMs (compile only mode)
148
149   --patchless
150     Build lustre client only
151
152   --distro=DISTRO
153     Which distro using. Autodetect by default
154
155   --kerneldir=KERNELDIR
156     Directory containing Linux source tarballs referenced by target
157     files.
158
159   --kerneltree=KERNELTREE
160     Directory containing dirs with Linux source tarballs referenced by target
161     files. Dir names in format kernel version ('2.6.9', etc.)
162
163   --linux=LINUX --with-linux=LINUX
164     Directory of Linux kernel sources.  When this option is used, only
165     Lustre modules and userspace are built.
166
167   --lustre=LUSTRE
168     Path to an existing lustre source tarball to use.
169
170   --nodownload
171     Do not try to download a kernel from downloads.hpdd.intel.com
172
173   --nosrc
174     Do not build a .src.rpm, a full kernel patch, or a patched kernel
175     tarball.
176
177   --ldiskfs
178     Build with ldiskfs support. (Deprecated, always true)
179
180   --noiokit
181     Do not build lustre-iokit RPM. Now true by default
182
183   --publish
184     Unused.
185
186   --release
187     Specifies that the files generated do not include timestamps, and
188     that this is an official release.
189
190   --src
191     Build a .src.rpm, a full kernel patch, and a patched kernel tarball.
192
193   --stage=DIR
194     Directory used to stage packages for release.  RPMs will be placed
195     more or less in DIR/<target>-<arch>, and the tarball will be
196     placed in DIR.
197
198   --target=TARGET
199     The name of the target to build.  The available targets are listed
200     below.
201
202   --target-archs=TARGET_ARCHS
203     A (space delimited) list of architectures to build.  By default,
204     all of the archs supported by the TARGET will be built, in
205     addition to a .src.rpm.  This option can limit those, for machines
206     that can only build certain archs or if you only want a certain
207     arch built (for testing, or a one-off kernel).
208
209     Also note that by using a non-"base" arch (eg, i386) only kernels
210     will be built - there will be no lustre-lite-utils package.
211
212   --xen
213     Builds a Xen domX kernel.
214
215   --set-value
216     Sets a variable to a given value.
217
218 EOF
219
220 #   list_targets
221
222     fatal "$1" "$2"
223 }
224
225 # canonicalize a relative path to a file
226 canon_filepath() {
227     local PATH="$1"
228
229     if [ ! -f "$PATH" ]; then
230         return 1
231     fi
232
233     local FILE=${PATH##*/}
234     local DIR=${PATH%/*}
235
236     echo $(canon_path "$DIR")/$FILE
237     return 0
238 }
239
240 # canonicalize a relative path to a dir
241 canon_path() {
242     local PATH="$1"
243
244     if [ ! -d "$PATH" ]; then
245         return 1
246     fi
247
248     pushd "$PATH" >/dev/null || return 1
249     local CANONPATH=$PWD
250     popd >/dev/null
251
252     echo "$CANONPATH"
253     return 0
254 }
255
256 check_options() {
257
258     if [ -z "$LUSTRE" -o ! -r "$LUSTRE" ]; then
259         usage 1 "Could not find Lustre source tarball '$LUSTRE'."
260     fi
261
262     if [ -z "$DISTRO" ] ; then
263         DISTRO=$(autodetect_distro)
264         # remove separator
265         DISTRO=${DISTRO/-/}
266     fi
267     DISTROMAJ=${DISTRO%%.*}
268
269     [ -z "$TARGET" ] && TARGET=$(autodetect_target "$DISTRO")
270
271     if [ -z "$LINUX" ]; then
272         [ "$KERNELDIR" -o "$KERNELTREE" ] || \
273             usage 1 "A kernel directory must be specified with --kerneldir or --kerneltree."
274
275         [ -d "$KERNELDIR" -o -d "$KERNELTREE" ] || \
276             usage 1 "$KERNELDIR and $KERNELTREE are not a directory."
277
278 #       TARGET_FILE="$TOPDIR/lustre/kernel_patches/targets/$TARGET.target"
279 #       [ -r "$TARGET_FILE" ] || \
280 #               usage 1 "Target '$TARGET' was not found."
281     fi
282
283     case $TARGET in
284         3.10-rhel7)
285             CANONICAL_TARGET="rhel7"
286             ;;
287         2.6-rhel6)
288             CANONICAL_TARGET="rhel6"
289             ;;
290         2.6-rhel5)
291             CANONICAL_TARGET="rhel5"
292             ;;
293         2.6-rhel4)
294             CANONICAL_TARGET="rhel-2.6"
295             ;;
296         2.6-suse)
297             CANONICAL_TARGET="sles-2.6"
298             ;;
299         2.6-sles10)
300             CANONICAL_TARGET="sles10-2.6"
301             ;;
302         2.6-sles11 | 3.0-sles11)
303             CANONICAL_TARGET="sles11"
304             ;;
305         2.6-oel5)
306             CANONICAL_TARGET="oel5"
307             ;;
308         hp_pnnl-2.4)
309             CANONICAL_TARGET="hp-pnnl-2.4"
310             ;;
311         2.6-vanilla \
312             | suse-2.4.21-2 \
313             | rh-2.4 \
314             | rhel-2.4 \
315             | sles-2.4 \
316             | 2.6-patchless)
317                 CANONICAL_TARGET="$TARGET"
318                 ;;
319     esac
320
321     local timestampnodig=$(echo $TIMESTAMP | sed -e s/[0-9]*//g)
322     [ "$timestampnodig" = "" ] || TIMESTAMP=$(date -d "$DATE" "+%Y%m%d%H%M%S")
323     local timestamplength="${#TIMESTAMP}"
324     if [ $timestamplength -eq 12 ]; then
325         TIMESTAMP="${TIMESTAMP}00"
326     elif [ $timestamplength -ne 14 ]; then
327         TIMESTAMP=$(date -d "$DATE" "+%Y%m%d%H%M%S")
328     fi
329
330     RPMBUILD=$(which rpmbuild 2>/dev/null | head -1)
331     if [ ! "$RPMBUILD" -o "$RPMBUILD" == "" ]; then
332         RPMBUILD=$(which rpm 2>/dev/null | head -1)
333         if [ ! "$RPMBUILD" -o "$RPMBUILD" == "" ]; then
334             usage 1 "Could not find binary for making rpms (tried rpmbuild and rpm)."
335         fi
336     fi
337
338     if [ -n "$CCACHE" ]; then
339         which "$DISTCC" &>/dev/null && export DISTCC RPM_BUILD_NCPUS
340
341         if which "$CCACHE" &>/dev/null; then
342             local ccache=$(which "$CCACHE")
343             local bindir="$TOPDIR/bin"
344
345             if [ ! -d $bindir ]; then
346                 mkdir -p $bindir || fatal 1 "error trying to create $bindir"
347             else
348                 rm ${bindir}/* > /dev/null 2>&1 || true
349             fi
350             ln -s "$ccache" ${bindir}/ccache
351             ln -s "$ccache" ${bindir}/cc
352             ln -s "$ccache" ${bindir}/$CC
353             export PATH=$bindir:$PATH
354             export CCACHE && export CC="ccache $CC"
355             # zero the cache so we can see how effective we are being with it
356             echo -n "ccache "
357             ccache -z
358
359             # get some ccache stats when we are done
360             push_exit_trap '[ -n "$CCACHE" ] && ccache -s' "ccache_summary"
361             # should remove the ccache trap if lbuild is interrupted
362             trap 'echo "Received an INT TERM or HUP signal, terminating."; delete_exit_trap "ccache_summary"; exit 1' INT TERM HUP
363         fi
364     fi
365
366     return 0
367
368 }
369
370 # compare two versions $1 and $2. if $1 < $2, return 0 otherwise return 1.
371 compare_version () {
372     [[ $1 == $2 ]] && return 1
373     local IFS=.
374     local i val1=($1) val2=($2)
375
376     # padding zero to val1 if it needs
377     for ((i=${#val1[@]}; i<${#val2[@]}; i++)); do
378         val1[i]=0
379     done
380     for ((i=0; i<${#val1[@]}; i++)); do
381         [[ -z ${val2[i]} ]] && return 1
382
383         if [[ ${val1[i]} < ${val2[i]} ]]; then
384             return 0
385         elif [[ ${val1[i]} > ${val2[i]} ]]; then
386             return 1
387         fi
388     done
389 }
390
391 uniqify() {
392
393     echo $(echo "$*" | xargs -n 1 | sort -u)
394
395 }
396
397 fetch_url() {
398     local url="$1"
399     local target="$2"
400
401     if [ -z "$target" ]; then
402         fatal 1 "fetch_url() called without a target to fetch to"
403     fi
404
405     if [ -d $target ]; then
406         target+="/${url##*/}"
407     fi
408
409     local rc=0
410     if which wget >/dev/null 2>&1; then
411         if ! wget -nv "$url" -O "$target"; then
412             rc=${PIPESTATUS[0]}
413         fi
414     elif which curl >/dev/null 2>&1; then
415         if ! curl -n -L -s -o "$target" "$url"; then
416             rc=${PIPESTATUS[0]}
417         fi
418     else
419         fatal 1 "Could not find either wget or curl to fetch URLs."
420     fi
421
422     return $rc
423
424 }
425
426 download_srpm() {
427     local target=$1
428     local srpm=$2
429     local force="${3:-false}"
430
431     if $force || [ ! -r "$KERNELDIR/$srpm" ] ||
432        [ ! -s "$KERNELDIR/$srpm" ]; then
433         if $DOWNLOAD; then
434             local location="https://downloads.hpdd.intel.com/public/kernels/$target/old"
435             # get the location from a distro specific method if it exists
436             if type -p kernel_srpm_location; then
437                 location=$(kernel_srpm_location)
438             fi
439             echo "Downloading $location/$srpm..."
440             if ! fetch_url "$location/$srpm" "$KERNELDIR/$srpm" 2>&1 ||
441                [ ! -s "$KERNELDIR/$srpm" ]; then
442                 rm -f $KERNELDIR/$srpm
443                 # punt to a distro specific method if it exists
444                 if ! type -p download_srpm-$DISTROMAJ; then
445                     fatal 1 "Could not download target $target's kernel SRPM $srpm from $location."
446                 else
447                     if ! download_srpm-$DISTROMAJ "$target" "$srpm" "$force"; then
448                         fatal 1 "Could not download target $target's kernel SRPM $srpm using download_srpm-$DISTROMAJ."
449                     fi
450                 fi
451             fi
452         else
453             fatal 1 "$srpm not found in directory $KERNELDIR."
454         fi
455     fi
456
457 }
458
459 download_file() {
460     local from="$1"
461     local to="$2"
462     local force="$3"
463
464     local file=${from##*/}
465
466     if [ -d $to ]; then
467         to="$to/$file"
468     fi
469
470     local semaphore="$to-downloading"
471
472     is_downloading() {
473         if [ ! -f $semaphore ]; then
474             return 1
475         fi
476
477         # make sure the download has not been aborted
478         local now=$(date +%s)
479         local file_mtime=$(stat -c %Y "$to")
480         local staleness=$((now - file_mtime))
481         # let's assume an active download will write at least once a minute
482         if [ $staleness -gt 60 ]; then
483             return 1
484         fi
485
486         return 0
487     }
488
489     is_downloaded() {
490         # if the semaphore file exists, the file is either still downloading
491         # or a download was aborted and we cannot trust the target file
492         if [ -f $semaphore ]; then
493             return 1
494         fi
495
496         if ! is_downloading && [ -r "$to" ] && [ -s "$to" ]; then
497             return 0
498         fi
499
500         return 1
501     }
502
503     if $force || ! is_downloaded; then
504         if is_downloading; then
505             echo "Somebody else is downloading $from..."
506             while is_downloading; do
507                 echo "Waiting for $to to finish downloading"
508                 sleep 60
509             done
510             if is_downloaded; then
511                 return 0
512             else
513                 echo "The download we were waiting for seems to have been aborted"
514             fi
515
516         fi
517
518         if $DOWNLOAD; then
519             echo "Downloading $from..."
520             # flag others so they don't try to download also
521             push_exit_trap "rm -f $to $semaphore" "download"
522             touch $semaphore
523             if ! fetch_url "$from" "$to" || [ ! -s "$to" ]; then
524                 # the trap will remove the files via the fatal below
525                 fatal 1 "Could not download ${to##*/} from ${from%/*}/."
526             fi
527             rm -f $semaphore
528             delete_exit_trap "download"
529         else
530             fatal 1 "${to##*/} not found in directory ${to%/*}."
531         fi
532     fi
533
534     return 0
535
536 }
537
538 download_ofed() {
539     local force="${1:-false}"
540
541     if [ -z "$OFED_VERSION" -o "$OFED_VERSION" = "inkernel" ]; then
542         return 0
543     fi
544
545     local OFED_BASE_VERSION=$OFED_VERSION
546     if [[ $OFED_VERSION = *.*.*.* ]]; then
547         OFED_BASE_VERSION=${OFED_VERSION%.*}
548     fi
549
550     local location="https://www.openfabrics.org/downloads/OFED/ofed-${OFED_BASE_VERSION}/"
551
552     if [[ $OFED_VERSION = *-[rR][cC][0-9] ]]; then
553         local Mmv
554         Mmv=${OFED_VERSION%%-[rR][cC][0-9]}
555         location="http://www.openfabrics.org/downloads/OFED/ofed-${Mmv}/"
556     fi
557
558     if [[ $OFED_VERSION = daily-* ]]; then
559         local Mmv daily
560         OFED_VERSION=${OFED_VERSION/daily-/}
561         Mmv=${OFED_VERSION%%-*}
562         daily=${OFED_VERSION##$Mmv-}
563         location="http://www.openfabrics.org/downloads/OFED/ofed-${Mmv}-daily/"
564         # find the filename for the version for the date specified
565         OFED_VERSION=$(curl -s "$location" | sed -nre "/${daily}-/s/.*href=\"OFED-(${Mmv//./\\.}-${daily}-[0-9]{4,4}).tgz.*$/\1/p" | tail -1)
566         if [ -z "$OFED_VERSION" ]; then
567             fatal 1 "Could not determine the filename of the OFED snapshot for ${daily}"
568         fi
569     fi
570
571     local file="OFED-${OFED_VERSION}.tgz"
572     download_file "$location/$file" "$KERNELTREE" "$force"
573
574 }
575
576 parse_mpss_info() {
577     local file="$1"
578     local build="$2"
579     local distro="$3"
580
581     [ -r "$file" ] || fatal 1 "Could not find MPSS info file"
582
583     # convert to MPSS distro naming
584     distro=${distro/sles/suse}
585     distro_name=${distro%%-*}
586
587     # extract links from MPSS info file
588     local urls=$(cat "$file" | \
589         tr -d '\t\r\n' | sed -e 's?\(</[a-zA-Z]*>\)?\1\n?g' | \
590         grep '.intel.com/' | \
591         sed -e 's/^.*[hH][rR][eE][fF]="\([^>"]\+\)".*$/\1/g' | \
592         grep '.tar')
593     local res2=""
594     local res3=""
595     for url in $urls; do
596         local ver2=""
597         local ver3=""
598         # Try to match with MPSS 3.x or 3.x.x distro package
599         if [[ $url =~ mpss-[0-9].[0-9](.[0-9]*)?-$distro.tar ]]; then
600             ver3=${url##*mpss-}
601             ver3=${ver3%%-$distro.tar}
602         # Try to match with MPSS 3.x or 3.x.x source package
603         elif [[ $url =~ mpss-src-[0-9].[0-9](.[0-9]*)?.tar ]]; then
604             ver3=${url##*mpss-src-}
605             ver3=${ver3%%.tar}
606         # Try to match with MPSS 3.x or 3.x.x cross compiler package
607         elif [[ $url =~ mpss-[0-9].[0-9](.[0-9]*)?-k1om.tar ]]; then
608             ver3=${url##*mpss-}
609             ver3=${ver3%%-k1om.tar}
610         # Try to match with MPSS 2.1.x source package
611         elif [[ $url =~ _src-[0-9].[0-9].[0-9]*-[0-9]*_$distro_name.tar ]]; then
612             ver2=${url##*_src-}
613             ver2=${ver2%%_$distro_name.tar}
614         fi
615
616         if [ -n "$ver3" ]; then
617             # Check for MPSS 3.x or MPSS 3.x.x
618             if [[ $ver3 =~ [0-9].[0-9].[0-9]* ]]; then
619                 ver3="${ver3}-0"
620             else
621                 ver3="${ver3}.0-0"
622             fi
623             if [ -z "$build" ]; then
624                 res3="$ver3"
625             elif [ "$build" = "$ver3" ]; then
626                 res3="$res3 $url"
627             fi
628         elif [ -n "$ver2" ]; then
629             if [ -z "$build" ]; then
630                 res2="$ver2"
631             elif [ "$build" = "$ver2" ]; then
632                 res2="$res2 $url"
633             fi
634         fi
635
636     done
637
638     if [ -z "$build" ]; then
639         # return a last version of MPSS
640         if [ -n "$res3" ]; then
641             echo "$res3"
642         else
643             echo "$res2"
644         fi
645     elif [ "${build%%.*}" = "3" ]; then
646         local ver=${build%%-*}
647         local bid=${build##*-}
648         if [ $bid -eq 0 ]; then
649             # return URLs from MPSS info file
650             echo "$res3"
651         else
652             # Check for MPSS 3.x or MPSS 3.x.x
653             if [ ${ver##*.} -eq 0 ]; then
654                 ver=${ver%.*}
655             fi
656             # return URLs from internal site with MPSS builds
657             # kernel sources:
658             echo "${MPSS_BUILDS:-"http://mic-bld.pdx.intel.com/release"}/$ver/$bid/release/knightscorner/package/mpss-src-$ver.tar"
659             # kernel configs:
660             echo "${MPSS_BUILDS:-"http://mic-bld.pdx.intel.com/release"}/$ver/$bid/release/knightscorner/package/mpss-$ver-k1om.tar"
661             # OFED headers:
662             echo "${MPSS_BUILDS:-"http://mic-bld.pdx.intel.com/release"}/$ver/$bid/release/knightscorner/package/mpss-$ver-$distro.tar"
663         fi
664     else
665         # return URLs from MPSS info file
666         echo "$res2"
667     fi
668 }
669
670 # Get public information about last releases of
671 # Intel Manycore Platform Software Stack (MPSS)
672 download_mpss_info() {
673     local file="$1"
674     local force="${2:-true}"
675     local url=${MPSS_URL:-"http://software.intel.com/en-us/articles/intel-manycore-platform-software-stack-mpss"}
676
677     download_file "$url" "$file" "$force"
678 }
679
680 download_mpss() {
681     local file="$1"
682     local force="${2:-false}"
683     local urls=$(parse_mpss_info "$file" ${MPSS_VERSION} ${MPSS_DISTRO})
684
685     [ -z "$urls" ] && fatal 1 "Could not determine the URLs of MPSS $MPSS_VERSION"
686
687     # force re-download if build number is zero
688     [[ $MPSS_VERSION = [0-9].[0-9].[0-9]*-0 ]] && force=true
689
690     local url
691     local i=0
692     for url in $urls; do
693         file="$KERNELTREE/mpss_src-${MPSS_VERSION}-${MPSS_DISTRO}-part$i.tar"
694         download_file "$url" "$file" "$force"
695         i=$((i+1))
696     done
697 }
698
699 load_target() {
700
701     EXTRA_VERSION_save="$EXTRA_VERSION"
702     for patchesdir in "$EXTERNAL_PATCHES" \
703                       "$TOPDIR/lustre/lustre/kernel_patches"; do
704         TARGET_FILE="$patchesdir/targets/$TARGET.target"
705         [ -r "$TARGET_FILE" ] && break
706     done
707     [ -r "$TARGET_FILE" ] || fatal 1 "Target $TARGET was not found."
708
709     echo "Loading target config file $TARGET.target..."
710
711     # if the caller specified an OFED_VERSION it should override whatever
712     # the target file specifies
713     local env_OFED_VERSION="$OFED_VERSION"
714
715     . "$TARGET_FILE"
716
717     if [ -n "$env_OFED_VERSION" ]; then
718         OFED_VERSION="$env_OFED_VERSION"
719     fi
720
721     # doesn't make any sense to build OFED for xen domX's
722     if $XEN; then
723         OFED_VERSION=""
724     fi
725
726     # XXX - set_rpm_smp_type is an ugly undeterministic hack.  it needs to
727     #       go away and the target just specify the $RPMSMPTYPE
728     [ -z "$RPMSMPTYPE" ] && set_rpm_smp_type
729
730     # CC might have been overwriten in TARGET_FILE
731     if [[ $CC != ccache\ * ]] && which "$CCACHE" &>/dev/null; then
732         export CCACHE && export CC="ccache $CC"
733     fi
734
735     if [ ! "$KERNELTREE" = "" ] && [ -d "$KERNELTREE" ]; then
736         KERNELDIR="$KERNELTREE/${lnxmaj}"
737         [ -d "$KERNELDIR" ] || mkdir "$KERNELDIR"
738     fi
739
740     # verify the series is available
741     if [ "$SERIES" ]; then
742         for series in $SERIES; do
743             for patchesdir in "$EXTERNAL_PATCHES" "$TOPDIR/lustre/lustre/kernel_patches"; do
744                 [ -r "$patchesdir/series/$series" ] && continue 2
745             done
746             fatal 1 "Target $TARGET's series $SERIES could not be found.\nSearched:\n\t$EXTERNAL_PATCHES/series\n\t$TOPDIR/lustre/lustre/kernel_patches/series."
747         done
748     fi
749
750     # set the location of the .config file
751     local XENPOSTFIX=""
752     if $XEN; then
753         XENPOSTFIX="-xen"
754     fi
755
756     if [ -f $TOPDIR/lustre/lustre/kernel_patches/kernel_configs/kernel-$lnxmaj-$TARGET-$TARGET_ARCH.config ]; then
757         CONFIG_FILE="$TOPDIR/lustre/lustre/kernel_patches/kernel_configs/kernel-$lnxmaj-$TARGET$XENPOSTFIX-$TARGET_ARCH.config"
758     fi
759
760     local lnxrelnew=${lnxrel//-/_}
761
762     # remember the EXTRA_VERSION before we diddle it here
763     # XXX - we really should not diddle with any values read in from the
764     #       target file.  if we want to modify a value, we should create
765     #       a new variable.
766     PRISTINE_EXTRA_VERSION=$EXTRA_VERSION
767
768     if ! $PATCHLESS && [ ! -f "$CONFIG_FILE" ]; then
769         fatal 1 "Config file for target $TARGET missing from $TOPDIR/lustre/lustre/kernel_patches/kernel_configs/."
770     fi
771
772     if [ "$EXTRA_VERSION_save" ]; then
773         EXTRA_VERSION="$EXTRA_VERSION_save"
774     elif ! $RELEASE; then
775         # if there is no patch series, then this is not a lustre specific
776         # kernel.  don't make it look like one
777         if $PATCHLESS || [ -n "$SERIES" ]; then
778             EXTRA_VERSION=$(echo $EXTRA_VERSION | sed -e "s/\(.*_lustre\)\..*/\1/")
779             if ! $PATCHLESS && [ -n "$BUILDID" ]; then
780                 EXTRA_VERSION="${EXTRA_VERSION}.${BUILDID}"
781             fi
782         fi
783     fi
784     # EXTRA_VERSION=${EXTRA_VERSION//-/_}
785
786     ALL_ARCHS="$BASE_ARCHS $BIGMEM_ARCHS $BOOT_ARCHS $JENSEN_ARCHS $SMP_ARCHS $BIGSMP_ARCHS $PSERIES64_ARCHS $UP_ARCHS"
787
788     BUILD_ARCHS=
789     for arch in $(uniqify "$ALL_ARCHS"); do
790         if [ -z "$TARGET_ARCHS" ] ||
791            [[ \ $TARGET_ARCHS\  = *\ $arch\ * ]]; then
792             BUILD_ARCHS="$BUILD_ARCHS $arch"
793         fi
794     done
795     [ "$BUILD_ARCHS" ] || usage 1 "No available target archs to build."
796     echo "Building for: $BUILD_ARCHS"
797 }
798
799 tarflags() {
800     local file="$1"
801
802     echo -n '--wildcards '
803     case "$file" in
804         '')
805             fatal 1 "tarflags(): File name argument missing."
806             ;;
807         *.tar.gz | *.tgz)
808             echo '-zxf'
809             ;;
810         *.tar.bz2)
811             echo '-jxf'
812             ;;
813         *.tar)
814             echo '-xf'
815             ;;
816         *)
817             fatal 1 "tarflags(): Unrecognized tar extension in file: $1"
818             ;;
819     esac
820
821 }
822
823 untar() {
824     local tarfile="$1"
825     shift
826     local extractfile="$@"
827
828     echo "Untarring ${tarfile##*/}..."
829     tar $(tarflags "$tarfile") "$tarfile" $extractfile
830
831 }
832
833 unpack_ofed() {
834
835     if ! untar "$KERNELTREE/OFED-${OFED_VERSION}.tgz"; then
836         return 1
837     fi
838     [ -d OFED ] || ln -sf OFED-[0-9].[0-9]* OFED
839
840 }
841
842 unpack_lustre() {
843
844     untar "$LUSTRE" || fatal 1 "Error unpacking Lustre tarball"
845     [ -d lustre ] || ln -sf lustre-[0-9].[0-9]* lustre
846
847 }
848
849 unpack_mpss() {
850
851     [ -d mpss ] && return 0
852
853     if [ "${MPSS_VERSION%%.*}" = "3" ]; then
854         local ver=${MPSS_VERSION%%-*}
855         local file
856         local i
857         # Check for MPSS 3.x or MPSS 3.x.x
858         if [ ${ver##*.} -eq 0 ]; then
859             ver=${ver%.*}
860         fi
861         for i in $(seq 0 9); do
862             file="$KERNELTREE/mpss_src-${MPSS_VERSION}-${MPSS_DISTRO}-part$i.tar"
863             if [ -r "$file" ]; then
864                 untar "$file" \
865                     "mpss-$ver/*/linux-*.tar.bz2" \
866                     "mpss-$ver/*/kernel-dev-*.rpm" \
867                     "mpss-$ver/*/ofed-driver-*-devel-*.rpm"
868             fi
869         done
870         # Extract kernel configs
871         file=$(find mpss-$ver -type f -path "*/kernel-dev-*.rpm")
872         if ! rpm2cpio "$file" | cpio -idm; then
873             echo "Error extracting MPSS kernel configs"
874             return 1
875         fi
876         # Unpack kernel sources
877         file=$(find mpss-$ver -type f -path "*/linux-*.tar.bz2")
878         if ! untar "$file"; then
879             echo "Error unpacking MPSS kernel sources"
880             return 1
881         fi
882         # Extract OFED headers
883         file=$(find mpss-$ver -type f -path "*/ofed-driver-*-devel-*.rpm")
884         if ! rpm2cpio "$file" | cpio -idm; then
885             echo "Error extracting MPSS OFED headers"
886             return 1
887         fi
888         # Remove unpacked archives to save space
889         rm -rf mpss-$ver
890         # Make link to MPSS kernel sources
891         ln -sf linux-* mpss
892     else
893         local dir="mpss-${MPSS_VERSION}-${MPSS_DISTRO%%-*}"
894
895         mkdir $dir || return 255
896         pushd $dir >/dev/null || return 255
897         if ! untar "$KERNELTREE/mpss_src-${MPSS_VERSION}-${MPSS_DISTRO}-part0.tar" "*/gpl/*full_src*"; then
898             popd >/dev/null
899             rm -rf $dir
900             echo "Error unpacking MPSS tarball 1"
901             return 1
902         fi
903         local file=$(find . -type f -path "*/gpl/*full_src*")
904         if ! untar "$file"; then
905             popd >/dev/null
906             rm -rf $dir
907             echo "Error unpacking MPSS tarball 2"
908             return 1
909         fi
910         popd >/dev/null
911         ln -sf $dir mpss
912     fi
913
914 }
915
916 do_patch_linux() {
917
918     local do_patch=${1:-true}
919
920     FULL_PATCH="$PWD/lustre-kernel-${TARGET}-${EXTRA_VERSION}.patch"
921     [ -f "$FULL_PATCH" ] && rm -f "$FULL_PATCH"
922     $do_patch && pushd linux >/dev/null
923     for series in $SERIES; do
924         echo -n "Applying series $series:"
925         for patchesdir in "$EXTERNAL_PATCHES" "$TOPDIR/lustre/lustre/kernel_patches"; do
926             [ -r "$patchesdir/series/$series" ] || continue
927             SERIES_FILE="$patchesdir/series/$series"
928             for patch in $(<"$SERIES_FILE"); do
929                 echo -n " $patch"
930                 PATCH_FILE="$patchesdir/patches/$patch"
931                 [ -r "$PATCH_FILE" ] || \
932                     fatal 1 "Patch $patch does not exist in Lustre tree."
933                 cat "$PATCH_FILE" >> "$FULL_PATCH" || {
934                     rm -f $FULL_PATCH
935                     fatal 1 "Error adding patch $patch to full patch."
936                 }
937                 if $do_patch; then
938                     patch -s -p1 < "$PATCH_FILE" 2>&1 || {
939                         rm -f $FULL_PATCH
940                         fatal 1 "Error applying patch $patch."
941                     }
942                 fi
943             done
944             break
945         done
946         echo
947     done
948     $do_patch && popd >/dev/null
949     echo "Full patch has been saved in ${FULL_PATCH##*/}."
950
951 }
952
953 build_lustre() {
954     local linux="$1"
955     local linuxobj="$2"
956
957     cp "$LUSTRE" SOURCES
958
959     pushd lustre >/dev/null
960
961     if ! build_lustre_dkms; then
962         popd >/dev/null # pushd lustre
963         return 255
964     fi
965
966     echo "Building Lustre RPMs for: $BUILD_ARCHS..."
967     local targets arch
968     for arch in $BUILD_ARCHS; do
969         targets="--target $arch $targets"
970     done
971
972     local confoptions=""
973
974     if $PATCHLESS; then
975         confoptions="$confoptions --disable-server"
976     fi
977
978     local rpmbuildopt='-tb'
979     if $NORPM; then
980         rpmbuildopt='-tc'
981         echo NORPM mode. Only compiling.
982     fi
983
984     # If server we now build the spl and zfs modules against the lustre kernel.
985     # These are required prior to the building of lustre server. Client does
986     # not require spl/zfs. Use !PATCHLESS to indicate server which follows the
987     # line above so is at least consistant.
988     if [ $PATCHLESS == false ] && [ "x$ZFSNOTSUPPORTED" == "x" ]; then
989         if ! build_spl_zfs; then
990             popd >/dev/null # pushd lustre
991             return 255
992         fi
993     fi
994
995     if $PATCHLESS; then
996         RPMBUILD_DEFS="$RPMBUILD_DEFS --without servers"
997         if [ -n "$CROSS_SUFFIX" ]; then
998             RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"lustre_name lustre-client$CROSS_SUFFIX\""
999         fi
1000     fi
1001
1002     # ditto for the lustre-tests boolean
1003     if ! $LUSTRE_TESTS; then
1004         RPMBUILD_DEFS="$RPMBUILD_DEFS --without lustre_tests"
1005     fi
1006
1007     if ! $IOKITRPM; then
1008         RPMBUILD_DEFS="$RPMBUILD_DEFS --without lustre_iokit"
1009     fi
1010
1011     local osd_zfs=""
1012     if $OSDZFSRPM; then
1013         osd_zfs="yes"
1014     fi
1015
1016     local osd_ldiskfs=""
1017     if $OSDLDISKFSRPM; then
1018         osd_ldiskfs="yes"
1019     fi
1020
1021     RPMBUILD_DEFS="$RPMBUILD_DEFS ${FIND_REQUIRES:+--define \"__find_requires $FIND_REQUIRES\"}"
1022     RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"configure_args $confoptions ${CONFIGURE_FLAGS}\""
1023     RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"kdir $linux\""
1024     RPMBUILD_DEFS="$RPMBUILD_DEFS ${linuxobj:+--define \"kobjdir $linuxobj\"}"
1025     RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"_tmppath $TMPDIR\""
1026     RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"_topdir $TOPDIR\""
1027
1028     eval $RPMBUILD $targets $rpmbuildopt "$LUSTRE" $RPMBUILD_DEFS \
1029         ${osd_zfs:+--with zfs} \
1030         ${osd_ldiskfs:+--with ldiskfs} 2>&1 || \
1031         fatal 1 "Error building rpms for $BUILD_ARCHS."
1032
1033     if $DO_SRC; then
1034         if ! eval $RPMBUILD -ts "$LUSTRE" $RPMBUILD_DEFS 2>&1; then
1035             popd >/dev/null
1036             return 255
1037         fi
1038     fi
1039     popd >/dev/null
1040
1041 }
1042
1043 build_lustre_dkms() {
1044     [ -n "$MPSS_VERSION" ] && return 0
1045     local ver=$(eval echo  $(awk '/LUSTRE_VERSION_STRING/ {print $3}'  lustre/include/lustre_ver.h))
1046     echo "Building Lustre DKMS RPMs for: $BUILD_ARCHS..."
1047     ./configure --enable-dist || return 255
1048     $RPMBUILD --define="_topdir $TOPDIR" -bs lustre-dkms.spec || return 255
1049     $RPMBUILD --rebuild --define="_topdir $TOPDIR" $TOPDIR/SRPMS/lustre-dkms-$ver-*.src.rpm || return 255
1050     return 0
1051 }
1052
1053 ###
1054 # build_spl_zfs
1055 #
1056 # Fetch spl/zfs from the git repo and prepare for lustre build
1057 #
1058 # Overrides:
1059 #   SPLZFSGITREPO - URI of directory where spl.git and zfs.git are located
1060 #   SPLZFSTAG     - Tag to checkout of clone repositories
1061 #   SPLZFSVER     - Version to checkout of both (format zfs/spl-$SPLZFSVER)
1062 #
1063 # return 0 if successful, else 255
1064 build_spl_zfs() {
1065     # make sure the RPM build environment is set up
1066     pushd $TOPDIR
1067     create_rpmbuild_dirs
1068     popd
1069
1070     # The spl/zfs spec files expect RPM_BUILD_ROOT to point to the root of the
1071     # destination for the rpms
1072     export RPM_BUILD_ROOT=$TOPDIR
1073     SPLZFSVER=${SPLZFSVER:-0.6.3}
1074     SPLZFSTAG=${SPLZFSTAG:-}
1075
1076     # The files expect a kver to be set to the kernel version .
1077     local kver=$(find_linux_release)
1078
1079     # build and install the spl and zfs (and -devel) RPMs for lustre to use
1080     local pkg
1081     for pkg in spl zfs; do
1082
1083         local rpmpkg
1084
1085         [ "$pkg" == "zfs" ] && spldir="$(ls -d $TOPDIR/usr/src/spl-*/|tail -1)"
1086
1087         # need to fetch the repo in order to build it.
1088         # default to github but allow override
1089         git clone ${SPLZFSGITREPO:-"https://github.com/zfsonlinux"}/$pkg.git $pkg 2>&1
1090
1091         pushd $pkg || return 255
1092         if [ -n "$SPLZFSTAG" ]; then
1093             git checkout $SPLZFSTAG
1094         else
1095             git checkout -b lbuild $pkg-$SPLZFSVER
1096         fi
1097
1098         # This differentiates between older zfs versions
1099         if [ -f $pkg-modules.spec.in ]; then
1100             rpmpkg=$pkg-modules
1101             specdir=.
1102             speclist="$pkg.spec $rpmpkg.spec"
1103         else
1104             rpmpkg=kmod-$pkg-devel
1105             specdir=rpm/generic
1106             speclist="$pkg.spec $pkg-kmod.spec $pkg-dkms.spec"
1107         fi
1108
1109         sh autogen.sh || return 255
1110
1111         if  ! ./configure --with-linux=${LINUX} --with-linux-obj=${LINUXOBJ:-$LINUX} \
1112                           ${spldir:+--with-spl="${spldir}"} 2>&1 ||
1113             ! make dist 2>&1; then
1114             popd
1115             return 255
1116         fi
1117         popd
1118
1119         ln -f $pkg/$pkg-*.tar.gz $TOPDIR/SOURCES ||
1120            error "failed to link $pkg/$pkg-*.tar.gz into $TOPDIR/SOURCES"
1121         if [ -f $pkg/scripts/kmodtool ]; then
1122             ln -f $pkg/scripts/kmodtool $TOPDIR/SOURCES/
1123         fi
1124
1125         local rpmb
1126         if $DO_SRC; then
1127             rpmb=-ba
1128         else
1129             rpmb=-bb
1130         fi
1131
1132         # set search dir for our own kmodtool to find correct
1133         # directories
1134         export KERNELSOURCE=$(dirname ${LINUX})
1135         # Manually build rpms
1136         for spec in $speclist; do
1137             echo "Building RPMs from $pkg/$specdir/$spec"
1138             if ! $RPMBUILD $rpmb $pkg/$specdir/$spec \
1139                 --nodeps -v \
1140                 --define "require_kdir ${LINUX}" \
1141                 ${LINUXOBJ:+--define "require_kobj ${LINUXOBJ}"} \
1142                 ${spldir:+--define "require_spldir ${spldir}"} \
1143                 --define "kver $kver" \
1144                 --define "kernels $kver" \
1145                 --define "_tmppath /var/tmp" \
1146                 --define "kernelbuildroot $TOPDIR/reused" \
1147                 --define "_topdir $TOPDIR" 2>&1; then
1148                 return 255
1149             fi
1150         done
1151
1152         # We have built the rpms for the package. Now we need to extract the
1153         # contained files so we can build further things against them
1154         local rpms=$(ls -1 $TOPDIR/RPMS/*/$rpmpkg-*.rpm)
1155
1156         # cpio only extract to pwd so we need to go there.
1157         pushd $TOPDIR
1158         local rpm
1159         for rpm in $rpms; do
1160             rpm2cpio $rpm | cpio -id
1161         done
1162
1163         if [ "$pkg" == "zfs" ]; then
1164             # We also need to extract both the zfs and zfs-devel rpms
1165             # the zfs rpm is needed because it has the actual libraries in
1166             # it and the zfs-devel rpm only has unversioned symlinks to the
1167             # libraries in the zfs rpm
1168             # this will all change one day when we have a libzfs rpm per
1169             # https://github.com/zfsonlinux/zfs/issues/2329
1170             # and it looks like it could be one day soon:
1171             # https://github.com/zfsonlinux/zfs/pull/2341
1172             local devel_rpms=$(ls -1 $TOPDIR/RPMS/*/{$pkg-devel,$pkg-$SPLZFSVER,lib*}-*.rpm)
1173             for rpm in $devel_rpms; do
1174                 rpm2cpio $rpm | cpio -id
1175             done
1176             CONFIGURE_FLAGS="--with-$pkg-devel=$TOPDIR ${CONFIGURE_FLAGS}"
1177         fi
1178         popd
1179
1180         CONFIGURE_FLAGS="--with-$pkg=$(ls -d $TOPDIR/usr/src/$pkg-*/|tail -1) ${CONFIGURE_FLAGS}"
1181         CONFIGURE_FLAGS="--with-$pkg-obj=$(ls -d $TOPDIR/usr/src/$pkg-*/$kver*|tail -1) ${CONFIGURE_FLAGS}"
1182     done
1183
1184     OSDZFSRPM=true
1185
1186     return 0
1187 }
1188
1189 prepare_mpss() {
1190
1191     pushd mpss >/dev/null || return 255
1192     if [ "${MPSS_VERSION%%.*}" = "3" ]; then
1193         cp -f ../boot/config-* .config
1194         if ! make ARCH=k1om silentoldconfig ; then
1195             popd >/dev/null
1196             return 1
1197         fi
1198         if ! make ARCH=k1om modules_prepare ; then
1199             popd >/dev/null
1200             return 1
1201         fi
1202         cp -f ../boot/Module.symvers-* Module.symvers
1203     else
1204         if ! make defconfig-miclinux; then
1205             popd >/dev/null
1206             return 1
1207         fi
1208         if ! make -C card/kernel ARCH=k1om modules_prepare ; then
1209             popd >/dev/null
1210             return 1
1211         fi
1212     fi
1213     popd >/dev/null
1214
1215 }
1216
1217 stage() {
1218
1219     [ "$STAGEDIR" ] || return 0
1220
1221     for arch in $BUILD_ARCHS; do
1222         rpmdir="${STAGEDIR}/${CANONICAL_TARGET}-${arch}"
1223         echo "${0##*/}: Copying RPMs into ${rpmdir}"
1224         mkdir -p "${rpmdir}"
1225         cp -v RPMS/${arch}/*.rpm "${rpmdir}"
1226         if [ -d RPMS/noarch ]; then
1227             cp -v RPMS/noarch/*.rpm "${rpmdir}"
1228         fi
1229     done
1230
1231     cp -v "$LUSTRE" "$STAGEDIR"
1232
1233 }
1234
1235 set_rpm_smp_type() {
1236
1237     local infact_arch="${TARGET_ARCH}"
1238
1239     RPMSMPTYPE=""
1240     [ "$infact_arch" == "i586" ] && infact_arch="i686"
1241
1242     local smp_type
1243     for smp_type in $SMP_ARCHS; do
1244         [ $infact_arch == $smp_type ] && RPMSMPTYPE=smp && break
1245     done
1246
1247     for smp_type in $BIGSMP_ARCHS; do
1248         [ $infact_arch == $smp_type ] && RPMSMPTYPE=bigsmp && break
1249     done
1250
1251     for smp_type in $PPC64_ARCHS; do
1252         [ $infact_arch == $smp_type ] && RPMSMPTYPE=ppc64 && break
1253     done
1254
1255     for smp_type in $DEFAULT_ARCHS; do
1256         [ $infact_arch == $smp_type ] && RPMSMPTYPE=default && break
1257     done
1258
1259 }
1260
1261 # This function takes a linux include tree and digs out the linux release
1262 # from it. It is never called directly, only called from the distro
1263 # specific function find_linux_release() in lbuild-{rhel,sles}.
1264 _find_linux_release() {
1265     local SRC="$1"
1266     local LINUXRELEASEHEADER=""
1267
1268     LINUXRELEASEHEADER=$SRC/include/linux/version.h
1269     if [ -s $SRC/include/generated/utsrelease.h ]; then
1270         LINUXRELEASEHEADER=$SRC/include/generated/utsrelease.h
1271     elif [ -s $SRC/include/linux/utsrelease.h ]; then
1272         LINUXRELEASEHEADER=$SRC/include/linux/utsrelease.h
1273     fi
1274
1275     if [ ! -s $LINUXRELEASEHEADER ]; then
1276         fatal 1 "could not find UTS_RELEASE"
1277     fi
1278
1279     sed -ne 's/#define UTS_RELEASE "\(.*\)"$/\1/p' $LINUXRELEASEHEADER
1280 }
1281
1282 # unpack kernel(/source/devel) RPM
1283 #
1284 # This function and it's setting of $LINUX and $LINUXOBJ is a total hack that
1285 # needs to completely refactored.  It completely ingores that $BUILD_ARCHS may
1286 # contain a list of arches for which rpmbuild commands (including the one for
1287 # lustre itself)
1288 unpack_linux_devel_rpm() {
1289     local kernelrpm="${1}"
1290
1291     [ -f "$kernelrpm" ] || return 255
1292     [ -d $TOPDIR/reused ] || mkdir $TOPDIR/reused || return 255
1293
1294     pushd $TOPDIR/reused &>/dev/null || return 255
1295
1296     if ! rpm2cpio < "$kernelrpm" | cpio -id > /dev/null 2>&1; then
1297         return 255
1298     fi
1299
1300     # call a distro specific hook, if available
1301     if type -p unpack_linux_devel_rpm-$DISTROMAJ; then
1302         if ! unpack_linux_devel_rpm-$DISTROMAJ "$kernelrpm"; then
1303             return 255
1304         fi
1305     fi
1306
1307     popd &>/dev/null
1308
1309     find_linux_devel_paths $TOPDIR/reused
1310
1311     return 0
1312
1313 }
1314
1315 build_kernel_ib() {
1316     local linux="$1"
1317     local kib_prefix="$2"
1318     local kib_rpm="$3"
1319
1320     # build kernel-ib{,-devel}/compat-rdma{,-devel}
1321     local K_SRC="K_SRC"
1322     # ofed 1.3 had a bug in the rpm spec
1323     if [ "$OFED_VERSION" = "1.3" ]; then
1324         K_SRC="KSRC"
1325     fi
1326
1327     local OFED_CORE="--with-core-mod --with-ipoib-mod --with-sdp-mod --with-user_mad-mod --with-user_access-mod --with-addr_trans-mod"
1328     local OFED_HARDWARE="--with-mthca-mod --with-mlx4-mod --with-mlx4_en-mod --with-cxgb3-mod --with-nes-mod"
1329
1330     if compare_version $OFED_VERSION 3.0; then
1331         OFED_CORE="$OFED_CORE --with-madeye-mod --with-rds-mod"
1332     else
1333         OFED_HARDWARE="$OFED_HARDWARE --with-cxgb4-mod"
1334     fi
1335
1336     # some I/B drivers are architecture dependent and kernel-ib's configure
1337     # does not figure it out for us ~sigh~
1338     case "$TARGET_ARCH" in
1339         ppc64)
1340             OFED_HARDWARE="$OFED_HARDWARE --with-ehca-mod"
1341             ;;
1342     esac
1343     # we're no longer shipping the OFED iSCSI target
1344     #OFED_ISCSI="--with-srp-mod --with-srp-target-mod"
1345     OFED_ISCSI="--with-srp-mod"
1346     ## ISER module has no backport support as of OFED 1.5 (i.e. only builds on
1347     ##kernels >= 2.6.30)
1348     #if [[ $OFED_VERSION = 1.[0-4]* ]]; then
1349     #   OFED_ISCSI="$OFED_ISCSI --with-iser-mod"
1350     #fi
1351
1352     # assume we are just rebuilding the SRPM
1353     local BUILD_TYPE=${BUILD_TYPE:-"--rebuild"}
1354     local SOURCE="${TOPDIR}/OFED/SRPMS/${kib_prefix}-*.src.rpm"
1355
1356     # but switch to building from the SPEC if we need to apply patches
1357     if ls ${TOPDIR}/lustre/contrib/patches/ofed/* >/dev/null; then
1358         BUILD_TYPE="-bb"
1359         rpm --define "_topdir ${TOPDIR}" -ivh $SOURCE
1360         SOURCE="${TOPDIR}/SPECS/${kib_prefix}.spec"
1361         local file ed_fragment1 ed_fragment2 n=1
1362         for file in $(ls ${TOPDIR}/lustre/contrib/patches/ofed/*.patch); do
1363             ed_fragment1="$ed_fragment1
1364 Patch$n: ${file%%*/}"
1365             ed_fragment2="$ed_fragment2
1366 %patch$n -p0"
1367             cp $file ${TOPDIR}/SOURCES
1368             let n=$n+1
1369         done
1370         for file in $(ls ${TOPDIR}/lustre/contrib/patches/ofed/*.ed); do
1371             # Only apply the ed-scripts that should be used for the canonical target
1372             # ed-files in ${TOPDIR}/lustre/contrib/patches/ofed/ have to follow the naming
1373             # convention
1374             # <two-digits>-<descriptive-name>:<canonical_target_1>: ...:<canonical_target_N>.ed
1375             # To apply the same change to multiple canonical target simply specify
1376             # a list of colon separated canoncial target names in the file name.
1377             echo "$file" | grep -q -e ":${CANONICAL_TARGET}:" \
1378                                    -e ":${CANONICAL_TARGET}.ed$"
1379             if [ $? -eq 0 ] ; then
1380                 ed_fragment3="$ed_fragment3
1381 $(cat $file)"
1382                 let n=$n+1
1383             fi
1384         done
1385
1386         if [ $n -gt 1 ]; then
1387             ed $SOURCE <<EOF
1388 /^Source: /a
1389 $ed_fragment1
1390 .
1391 /^%setup /a
1392 $ed_fragment2
1393 .
1394 $ed_fragment3
1395 wq
1396 EOF
1397         fi
1398     fi
1399
1400     local linuxrelease=$(find_linux_release)
1401     if compare_version $OFED_VERSION 3.0; then
1402         local OFA_KERNEL_RELEASE=$(echo -n ${linuxrelease} | sed -e 's/-/_/g')
1403     fi
1404     if ! $RPMBUILD $BUILD_TYPE --define 'build_kernel_ib 1' --define 'build_kernel_ib_devel 1' \
1405                   ${FIND_REQUIRES:+--define "__find_requires $FIND_REQUIRES"} \
1406                   --define "_topdir ${TOPDIR}" --target ${TARGET_ARCH} \
1407                   --define "KVERSION ${linuxrelease}" \
1408                   --define "$K_SRC ${linux}" \
1409                   --define "LIB_MOD_DIR /lib/modules/${linuxrelease}/updates" \
1410                   ${OFA_KERNEL_RELEASE:+--define "_release $OFA_KERNEL_RELEASE"} \
1411                   --define "configure_options --without-quilt $OFED_CORE $OFED_HARDWARE $OFED_ISCSI" \
1412                   ${SOURCE} 2>&1; then
1413         fatal 1 "Error building ${kib_rpm}"
1414     fi
1415
1416 }
1417
1418 store_for_reuse() {
1419     local articles="$1"
1420     local module="$2"
1421     local location="$3"
1422     local signature="$4"
1423     local use_links="$5"
1424
1425     local linkflag=""
1426     if $use_links; then
1427         linkflag="l"
1428     fi
1429
1430     local default_iface=$(/sbin/ip route get 192.1.1.1 | sed -ne 's/.* dev \(.*\)  * src .*/\1/p')
1431     if [ -z "$default_iface" ]; then
1432         fatal 1 "Failed to determine the default route interface"
1433     fi
1434     local unique_id=$(/sbin/ip addr show dev $default_iface | sed -ne '/ inet /s/ *inet \(.*\)\/.*/\1/p' | head -1)
1435     if [ -z "$unique_id" ]; then
1436         fatal 1 "Failed to determine a unique id from interface $default_interface"
1437     fi
1438
1439     local finallocation="$location"/"$signature"/"$module"
1440     location="$location"/"$signature-${unique_id}"/"$module"
1441     mkdir -p "$location"
1442     # the cleanup script removes any directory that doesn't have a
1443     # .lastused, so let's try to prevent that as soon as we can
1444     # this solution still slightly racy with the cleanup script
1445     # but the race is a lot tighter now
1446     touch -t 197001010000 "$location/.lastused"
1447     ## use eval/echo here to make sure shell expansions are performed
1448     #if ! cp -a${linkflag} $(eval echo $articles) "$location"; then
1449     local article
1450     for article in $(eval echo $articles); do
1451         if ! cp -a${linkflag} "$article" "$location"; then
1452             error "Failed to copy \"$article\" to \"$location\" in store_for_reuse()"
1453             # rename the cache location so that it's not cached
1454             # product, but is around for analysis
1455             mv "$location"{,-bad-$(date +%s)} ||
1456                 error "failed to clean up a failed cache attempt" \
1457                       "in \"$location\" -- manual cleanup will be" \
1458                       "necessary"
1459             return 1
1460         fi
1461     done
1462
1463     # flag the cache as complete (i.e. in case lbuild was previously
1464     # interrupted while caching)
1465     touch "$location/.lastused"
1466
1467     # put the temporary location into the final location
1468     # (last one wins)
1469     mkdir -p "${finallocation%/*}"
1470     mv "$location" "$finallocation"
1471     rmdir "${location%/*}"
1472     return 0
1473
1474 }
1475
1476 reuse() {
1477     local module="$1"
1478     local dest="$2"
1479     local use_links="${3:-false}"
1480     local signature="$4"
1481
1482     if [ -n "$REUSEBUILD" ] && [ -d "$REUSEBUILD/$signature/$module" ]; then
1483         if [ ! -f "$REUSEBUILD/$signature/$module/.lastused" ]; then
1484             # the .lastused flag is populated at the end of the caching to
1485             # signal that the caching was completed.  if that flag is not
1486             # there, then the cache is invalid (and should be removed in fact)
1487             mv "$REUSEBUILD/$signature/$module"{,-bad-$(date +%s)} ||
1488                 fatal 1 "failed to clean up a bad cache in location $REUSEBUILD/$signature/$module\" -- manual cleanup will be necessary"
1489             return 1
1490         fi
1491
1492         # so that we know how stale this entry is
1493         touch $REUSEBUILD/$signature/$module/.lastused
1494
1495         if $use_links; then
1496             if ls $REUSEBUILD/$signature/$module/* >/dev/null 2>&1; then
1497                 cp -al $REUSEBUILD/$signature/$module/* $dest/
1498             fi
1499         else
1500             # copying is pretty heavy
1501             # cp -a $REUSEBUILD/$signature/$module/* $dest/
1502             # do some creative symlinking instead
1503             local dir
1504             for dir in BUILD SRPMS SPECS; do
1505                 if ls $REUSEBUILD/$signature/$module/$dir/* >/dev/null 2>&1; then
1506                     ln -s $REUSEBUILD/$signature/$module/$dir/* $dest/$dir
1507                 fi
1508             done
1509             # sources have to be copied by file because we need SOURCES to
1510             # be a dir we can write into
1511 # could overrun ls's arg list here
1512             #ls $REUSEBUILD/$signature/$module/SOURCES/* |
1513             find $REUSEBUILD/$signature/$module/SOURCES/ -type f |
1514                 xargs ln -t $dest/SOURCES -s
1515
1516             # same for RPMS/* dirs
1517 # could overrun ls's arg list here
1518             #ls $REUSEBUILD/$signature/$module/RPMS/$TARGET_ARCH/* |
1519             local dir
1520             for dir in $REUSEBUILD/$signature/$module/RPMS/*; do
1521                 mkdir -p $dest/RPMS/${dir##*/}
1522                 find $dir -type f |
1523                   xargs ln -t $dest/RPMS/${dir##*/} -s
1524             done
1525         fi
1526         return 0
1527     else
1528         return 1
1529     fi
1530 }
1531
1532 basearch() {
1533     local arch="$1"
1534
1535     if [[ $arch = i[3456]86 ]]; then
1536         echo "i386"
1537     else
1538         echo "$arch"
1539     fi
1540
1541 }
1542
1543 build_kernel_with_srpm() {
1544     local outfd=$1
1545
1546     if [ -z "$outfd" ] || [ $outfd = 1 ]; then
1547         fatal 1 "You must supply a file descriptor to ${FUNCNAME[0]} and it cannot be 1"
1548     fi
1549
1550     # need to generate the patch for this target
1551     do_patch_linux false >&${outfd}    # sets global $FULL_PATCH (yeah, yuck)
1552
1553     # get an md5sum of the kernel patch + config for reuse check
1554     # XXX really, there needs to be a signature and a CONFIG_FILE per arch
1555     #     in BUILD_ARCHS
1556     local release_str
1557     if $RELEASE; then
1558         local release_str="RELEASE=$RELEASE\n"
1559     fi
1560
1561     if $USE_BUILD_CACHE && [ -n "$REUSEBUILD" ]; then
1562         local REUSE_SIGNATURE=$({ echo -en $release_str;
1563                                   echo $BUILD_GEN;
1564                                   cat "$CONFIG_FILE";
1565                                   cat "$TARGET_FILE";
1566                                   cat "$FULL_PATCH";
1567                                   cat "$LBUILD_DIR/lbuild";
1568                                   cat "$LBUILD_DIR/lbuild-$DISTROMAJ"; } |
1569                                 md5sum | cut -d" " -f1)
1570         # see if we can link to the reuse pool
1571         # XXX - hrm.  i'm not convinced this doesn't belong in the reuse
1572         #       "library"
1573         local CAN_LINK_FOR_REUSE=false
1574         touch $REUSEBUILD/$$
1575         if cp -al $REUSEBUILD/$$ $TOPDIR/ 2>/dev/null; then
1576             CAN_LINK_FOR_REUSE=true
1577         fi
1578         rm $REUSEBUILD/$$
1579     fi
1580
1581     # the extra version string to use for the kernel (which might be a reused
1582     # kernel, remember)
1583     local kernel_extra_version=""
1584     if ! $USE_BUILD_CACHE || ! reuse kernel "$TOPDIR" "$CAN_LINK_FOR_REUSE" \
1585                                    "$REUSE_SIGNATURE"; then
1586         # nothing cached, build from scratch
1587         if [ ! -r "$KERNELDIR/$KERNEL_SRPM" ]; then
1588             echo "Downloading kernel SRPM" >&${outfd}
1589             download_srpm "$CANONICAL_TARGET" "$KERNEL_SRPM" >&${outfd}
1590         fi
1591
1592         if ! rpm -ivh $KERNELDIR/$KERNEL_SRPM \
1593                   --define "_topdir $TOPDIR" >&${outfd} 2>&1; then
1594             # should we clean this up or leave it for analysis?
1595             #rm -rf $RPMTOPDIR
1596             fatal 1 "Error installing kernel SRPM."
1597         fi
1598
1599         # put the Lustre kernel patch into the RPM build tree
1600         cp $FULL_PATCH $TOPDIR/SOURCES/linux-${lnxmaj}-lustre.patch
1601         prepare_and_build_srpm >&${outfd} ||
1602             fatal 1 "failed to prepare_and_build_srpm"
1603
1604         if [ -z "$REUSE_SIGNATURE" ]; then
1605             echo "No reuse signature was caculated so not storing the built kernel" >&${outfd}
1606         else
1607             # store the resulting kernel RPM build tree for future use
1608             echo "Storing the built kernel for future reuse" >&${outfd}
1609             if ! store_for_reuse "$TOPDIR/{SPECS,SOURCES,SRPMS,RPMS}" \
1610                                  "kernel" "$REUSEBUILD" "$REUSE_SIGNATURE" \
1611                                  "$CAN_LINK_FOR_REUSE"; then
1612                 error "Failed to store kernel RPMS for reuse"
1613                 echo "unknown" >&${outfd}
1614                 return 1
1615             fi
1616         fi
1617     fi  # build reuse
1618
1619     # figure out the EXTRA_VERSION of the kernel we built or are re-using
1620     local KERNEL_RPM
1621     if ! KERNEL_RPM=$(find_rpm "$TOPDIR/RPMS/$TARGET_ARCH/" provides "^kernel(-default)? ="); then
1622         fatal 1 "Failed to find a kernel RPM in $TOPDIR/RPMS/$TARGET_ARCH/"
1623     fi
1624     kernel_extra_version=$(rpm -q --queryformat "%{RELEASE}" -p $TOPDIR/RPMS/$TARGET_ARCH/$KERNEL_RPM)
1625
1626     # should now have the following RPMs
1627     # $TOPDIR/RPMS/$arch/kernel-lustre-2.6.18-53.1.21.el5_lustre.1.6.5.1.$arch.rpm
1628     # $TOPDIR/RPMS/$arch/kernel-lustre-devel-2.6.18-53.1.21.el5_lustre.1.6.5.1.$arch.rpm
1629     # $TOPDIR/RPMS/$arch/kernel-lustre-headers-2.6.18-53.1.21.el5_lustre.1.6.5.1.$arch.rpm
1630     # $TOPDIR/RPMS/$arch/kernel-lustre-debuginfo-common-2.6.18-53.1.21.el5_lustre.1.6.5.1.$arch.rpm
1631     # $TOPDIR/RPMS/$arch/kernel-lustre-debuginfo-2.6.18-53.1.21.el5_lustre.1.6.5.1.$arch.rpm
1632
1633     echo $kernel_extra_version
1634     return 0
1635
1636 }
1637
1638 # build OFED
1639 # globals used:
1640 #    TOPDIR
1641 #    REUSEBUILD, USE_BUILD_CACHE
1642 #    CONFIGURE_FLAGS
1643
1644 build_ofed() {
1645     local linux="$1"
1646     local ofed_version="$2"
1647     local kib_prefix
1648     local kib_rpm
1649
1650     # if an ofed version is given, then it means use OFED proper,
1651     # not any vendor specific "inkernel" version
1652     if [ -z "$ofed_version" ]; then
1653         return 0
1654     fi
1655
1656     if [ "$ofed_version" = "inkernel" ]; then
1657         # see if there is a distro specific override for this and use
1658         # that if it exists
1659         # XXX we need to better integrate a distro specific override with
1660         #     the rest of this function so that all of the reuse cache
1661         #     stuff is leveraged given that 80% of this function is reuse
1662         if type -p build_ofed-$DISTROMAJ; then
1663             local ofed_location
1664             ofed_location=$(build_ofed-$DISTROMAJ ${STDOUT})
1665             local rc=${PIPESTATUS[0]}
1666             CONFIGURE_FLAGS="--with-o2ib=${ofed_location} ${CONFIGURE_FLAGS}"
1667             return $rc
1668         else
1669             return 0
1670         fi
1671     elif compare_version $OFED_VERSION 3.0; then
1672         kib_prefix="ofa_kernel"
1673         kib_rpm="kernel-ib"
1674     else
1675         kib_prefix="compat-rdma"
1676         kib_rpm="compat-rdma"
1677     fi
1678
1679     # build kernel-ib/compat-rdma
1680     if $USE_BUILD_CACHE && [ -n "$REUSEBUILD" ]; then
1681         local REUSE_SIGNATURE=$({ echo "$ofed_version";
1682                                   echo "$(find_linux_release;
1683                                   echo "$BUILD_GEN")";
1684                                   cat "${linux}/include/linux/autoconf.h";
1685                                   cat "$LBUILD_DIR/lbuild";
1686                                   cat "$LBUILD_DIR/lbuild-$DISTROMAJ"; } |
1687                                 md5sum | cut -d" " -f1)
1688         # see if we can link to the reuse pool
1689         # XXX - hrm.  i'm not convinced this doesn't belong in the reuse
1690         #       "library"
1691         local CAN_LINK_FOR_REUSE=false
1692         touch $REUSEBUILD/$$
1693         if cp -al $REUSEBUILD/$$ $TOPDIR/; then
1694             CAN_LINK_FOR_REUSE=true
1695         fi
1696         rm $REUSEBUILD/$$
1697     fi
1698
1699     if ! $USE_BUILD_CACHE || ! reuse ofed "$TOPDIR" "$CAN_LINK_FOR_REUSE" \
1700                                    "$REUSE_SIGNATURE"; then
1701         if [ -n "$REUSE_SIGNATURE" ]; then
1702             # stash away the existing built articles for a moment
1703             mkdir bak
1704             mv {BUILD,{S,}RPMS,S{OURCE,PEC}S} bak
1705             function mv_back {
1706                 pushd bak
1707                 find . | cpio -pudlm ..
1708                 popd
1709                 rm -rf bak
1710             }
1711             create_rpmbuild_dirs
1712         fi
1713         # build it
1714         build_kernel_ib "${linux}" "${kib_prefix}" "${kib_rpm}"
1715
1716         if [ -z "$REUSE_SIGNATURE" ]; then
1717             echo "No reuse signature was caculated so not storing the built ofed"
1718         else
1719             # store the resulting RPM build tree for future use
1720             echo "Storing the built ofed for future reuse"
1721             if ! store_for_reuse "$TOPDIR/{SPECS,SOURCES,BUILD,SRPMS,RPMS}" \
1722                                  "ofed" "$REUSEBUILD" "$REUSE_SIGNATURE" \
1723                                  "$CAN_LINK_FOR_REUSE"; then
1724                 error "Failed to store OFED RPMS for reuse"
1725                 mv_back
1726                 return 1
1727             fi
1728             # put the stuff we stashed away back
1729             mv_back
1730         fi
1731     fi
1732
1733     pushd "$TOPDIR" >/dev/null
1734     rm -rf ${kib_rpm}-devel
1735     mkdir ${kib_rpm}-devel
1736     cd ${kib_rpm}-devel
1737     # the actual ofed RPMs don't have the -rc$n or -$date string appened that
1738     # might be present on the file
1739     #local linuxrelease=$(find_linux_release)
1740     #ofed_version=$(echo $ofed_version |
1741     #               sed -re 's/-(20[0-9]{6,6}-[0-9]{4,4}|rc[0-9]*)$//')
1742     # FIXME
1743     # OFED version will have 'hyphen' for minor release. (e.g. 3.5-1, instead
1744     # of 3.5.1) compat-rdma and compat-rdma-devel could have same version
1745     # number, but currectly not. Once OFED fix this in the future release, we
1746     # can remove following filter.
1747     #ofed_version=$(echo $ofed_version |
1748     #               sed -re 's/-([0-9]*-[rR][cC][0-9]*)$//')
1749     #local rpm=$(ls $TOPDIR/RPMS/*/${kib_rpm}-devel-${ofed_version}-${linuxrelease//-/_}.*.rpm)
1750     # I dont' know why we have gone through the trouble to filter out the name
1751     # of the rpm there should only be one ${kib_rpm}-devel built
1752     local rpm=$(ls $TOPDIR/RPMS/*/${kib_rpm}-devel-*.rpm)
1753     if ! rpm2cpio < $rpm | cpio -id; then
1754         fatal 1 "could not unpack the ${kib_rpm}-devel rpm."
1755     fi
1756     CONFIGURE_FLAGS="--with-o2ib=$(pwd)/usr/src/${kib_prefix} ${CONFIGURE_FLAGS}"
1757     popd >/dev/null
1758
1759 }
1760
1761 build_with_srpm() {
1762
1763     if ! $PATCHLESS; then
1764         local kernel_extra_version
1765         if ! kernel_extra_version=$(build_kernel_with_srpm ${STDOUT}); then
1766             fatal 1 "Failed to build the kernel from it's SRPM"
1767         fi
1768
1769         for arch in $BUILD_ARCHS; do
1770             local kernel_devel_rpm
1771             if ! kernel_devel_rpm=$(find_rpm "$TOPDIR/RPMS/$arch/" provides "^$(devel_kernel_name $KERNEL_LUSTRE_NAMING) ="); then
1772                 fatal 1 "Failed to find a kernel development RPM in $TOPDIR/RPMS/$arch/"
1773             fi
1774
1775             # install the -devel RPM in preparation for modules builds
1776             if ! lnxrel="$kernel_extra_version" unpack_linux_devel_rpm \
1777                            "$TOPDIR/RPMS/$arch/$kernel_devel_rpm"; then
1778                 fatal 1 "Could not find the Linux tree in $TOPDIR/RPMS/$arch/$kernel_devel_rpm"
1779             fi
1780         done
1781     else
1782         # need to find and unpack the vendor's own kernel-devel for patchless
1783         # client build
1784         local kernelrpm
1785         if ! kernelrpm=$(find_linux_rpm "-$DEVEL_KERNEL_TYPE"); then
1786             fatal 1 "Could not find the kernel-$DEVEL_KERNEL_TYPE RPM in $KERNELRPMSBASE/$lnxmaj/$DISTROMAJ"
1787         fi
1788         if ! lnxrel="$lnxrel" unpack_linux_devel_rpm "$kernelrpm" "-"; then
1789             fatal 1 "Could not find the Linux tree in $kernelrpm"
1790         fi
1791     fi
1792
1793     # ~sigh~  have to make copies of and modify some of the rpm
1794     # infrastructure files so that find-requires can find our unpacked
1795     # kernel-devel artifacts
1796     cp $RPM_HELPERS_DIR/{symset-table,find-requires{,.ksyms}} .
1797     FIND_REQUIRES="$(pwd)/find-requires"
1798     chmod 755 {symset-table,find-requires{,.ksyms}}
1799     local tmp="$(pwd)"
1800     tmp="${tmp//\//\\/}"
1801     ed find-requires <<EOF
1802 1a
1803 set -x
1804 .
1805 /|.*find-requires.ksyms/s/|/| bash -x/
1806 g/ [^ ]*\/\(find-requires\.ksyms\)/s// $tmp\/\1/g
1807 wq
1808 EOF
1809     ed find-requires.ksyms <<EOF
1810 1a
1811 set -x
1812 .
1813 g/\/.*\/\(symset-table\)/s//$tmp\/\1/g
1814 wq
1815 EOF
1816     ed symset-table <<EOF
1817 1a
1818 set -x
1819 .
1820 g/\(\/boot\/\)/s//$tmp\/reused\1/g
1821 g/\(\/usr\/src\/kernels\/\)/s//$tmp\/reused\1/g
1822 wq
1823 EOF
1824
1825     build_ofed "${LINUXOBJ:-$LINUX}" "$OFED_VERSION" ||
1826         fatal 1 "error building OFED"
1827
1828     # now build Lustre
1829     if build_lustre "$LINUX" "$LINUXOBJ"; then
1830         # the build worked.  resolve any symlinked files (i.e. from reuse)
1831         # in RPMS/$arch to real files so that that that huge mess of
1832         # complication known as LTS can copy them yet somewhere else.
1833         # is it any wonder this whole process is so damn so?  anyone ever
1834         # heard of hardlinks?  it's this cool new thing that allows you save
1835         # tons of time and space by creating... well you can go read about
1836         # them if you have not heard about them yet.
1837         # can i say how much the implemenation of all of this really impedes
1838         # RPM reuse?
1839         local dir
1840         for dir in RPMS/*; do
1841             pushd $dir
1842             for file in $(ls); do
1843                 if [ -h $file ]; then
1844                     cp $file foo
1845                     mv foo $file
1846                 fi
1847             done
1848             popd
1849         done
1850         # also, for i?86, make sure all of the RPMs are in RPMS/$TARGET_ARCH
1851         # as that's where LTS expects to find them
1852         for dir in RPMS/*; do
1853             if [ $dir = RPMS/$TARGET_ARCH ]; then
1854                 continue
1855             fi
1856             pushd $dir
1857             local files=$(ls)
1858             if [ -n "$files" ]; then
1859                 cp -al $files ../$TARGET_ARCH
1860             fi
1861             popd
1862         done
1863     else
1864         return 1
1865     fi
1866
1867 }
1868
1869 create_rpmbuild_dirs() {
1870
1871     [ -d RPMS ] || mkdir RPMS
1872     for arch in $BUILD_ARCHS; do
1873         if [[ $arch = i?86 ]]; then
1874             # some stupidity in the sles11 kernel spec requires an RPMS/i386
1875             # even if the target arch is i686
1876             [ -d RPMS/i386 ] || mkdir RPMS/i386
1877         fi
1878         [ -d RPMS/$arch ] || mkdir RPMS/$arch
1879     done
1880     [ -d RPMS/noarch ] || mkdir RPMS/noarch
1881     [ -d BUILD ] || mkdir BUILD
1882     [ -d SOURCES ] || mkdir SOURCES
1883     [ -d SPECS ] || mkdir SPECS
1884     [ -d SRPMS ] || mkdir SRPMS
1885
1886 }
1887
1888 new_list() {
1889
1890     echo ""
1891
1892 }
1893
1894 add_list() {
1895     local list="$1"
1896     local item="$2"
1897
1898     echo "$list $item"
1899
1900 }
1901
1902 is_list_member() {
1903     local list="$1"
1904     local item="$2"
1905
1906     [[ $list\  == *\ $item\ * ]]
1907
1908 }
1909
1910 #########################################################################
1911 # Generate a backtrace through the call stack.
1912 #
1913 # Input: None
1914 # Output: None
1915 #########################################################################
1916 backtrace() {
1917     local strip=${1:-1}
1918
1919     local funcname="" sourcefile="" lineno="" n
1920
1921     echo "Call stack: (most recent first)"
1922     for (( n = $strip ; n < ${#FUNCNAME[@]} ; ++n )) ; do
1923         funcname=${FUNCNAME[$n - 1]}
1924         sourcefile=$(basename ${BASH_SOURCE[$n]})
1925         lineno=${BASH_LINENO[$n - 1]}
1926         if [ $n = 1 ]; then
1927             let lineno-=11
1928         fi
1929         # Display function arguments
1930         if [[ ! -z "${BASH_ARGV[@]}" ]]; then
1931             local args newarg j p=0
1932             for (( j = ${BASH_ARGC[$n - 1]}; j > 0; j-- )); do
1933                 newarg=${BASH_ARGV[$j + $p - 1]}
1934                 args="${args:+${args} }'${newarg}'"
1935             done
1936             let p+=${BASH_ARGC[$n - 1]}
1937         fi
1938         echo "  ${funcname} ${args:+${args} }at ${sourcefile}:${lineno}"
1939     done
1940
1941     echo
1942     echo "BEGIN BACKTRACE"
1943
1944     #echo ${BASH_LINENO[*]}
1945     #echo ${BASH_SOURCE[*]}
1946     #echo ${FUNCNAME[*]}
1947     local i=$((${#FUNCNAME[@]} - 1))
1948     while [ $i -ge 0 ]; do
1949         local lineno=${BASH_LINENO[$i]}
1950         if [ $i = 0 ]; then
1951             let lineno-=11
1952         fi
1953         local SOURCELINE="${BASH_SOURCE[$i + 1]}:${lineno}"
1954         # Can't figure out how to get function args from other frames...
1955         local FUNCTION="${FUNCNAME[$i]}()"
1956         echo "$SOURCELINE:$FUNCTION"
1957         i=$((i - 1))
1958     done
1959
1960     echo "END BACKTRACE"
1961
1962     echo $BACKTRACE
1963
1964 }
1965
1966 seen_list=$(new_list)
1967 trap 'set +x;
1968 echo "An unexpected error has occurred at ${BASH_SOURCE[0]##*/}:$((LINENO-1)).
1969 Unfortunately the above line number in the message may or may not be correct,
1970 but details have been send to the lbuild maintainer.  Attempting to continue."; (echo "Untrapped error"
1971 echo
1972 # have we seen this one
1973 echo "checking seen list for ${BASH_SOURCE[0]}:${BASH_LINENO[0]}"
1974
1975 if is_list_member "$seen_list" "${BASH_SOURCE[0]}:${BASH_LINENO[0]}"; then
1976   echo "seen this one already"
1977 else
1978   seen_list=$(add_list "$seen_list" "${BASH_SOURCE[0]}:${BASH_LINENO[0]}")
1979 fi
1980 backtrace
1981 ) ; set $xtrace' ERR
1982 set -E
1983
1984 [ -r ~/.lbuildrc ] && . ~/.lbuildrc
1985
1986 options=$(getopt -o D:h -l kerneltree:,distro:,kernelrpm:,reusebuild:,patchless,ccache,norpm,external-patches:,timestamp:,extraversion:,kerneldir:,linux:,lustre:,nodownload,nosrc,noiokit,ofed-version:,mpss-version:,publish,release,set-value:,src,stage:,target:,target-archs:,with-linux:,xen -- "$@")
1987
1988 if [ $? != 0 ]; then
1989     usage 1
1990 fi
1991
1992 eval set -- "$options"
1993
1994 while [ "$1" ]; do
1995     case "$1" in
1996         '')
1997             usage 1
1998             ;;
1999         --ccache)
2000             CCACHE='ccache'
2001             shift
2002             ;;
2003         -D)
2004             DATE=$2
2005             shift 2
2006             ;;
2007         --external-patches)
2008             EXTERNAL_PATCHES=$2
2009             shift 2
2010             ;;
2011         --extraversion)
2012             EXTRA_VERSION=$2
2013             shift 2
2014             ;;
2015         --help | -h)
2016             usage 0
2017             ;;
2018         --kerneldir)
2019             KERNELDIR=$2
2020             shift 2
2021             ;;
2022         --kerneltree)
2023             if ! KERNELTREE=$(canon_path "$2"); then
2024                 fatal 1 "Could not determine the canonical location of $2"
2025             fi
2026             shift 2
2027             ;;
2028         --linux | --with-linux)
2029             if ! LINUX=$(canon_path "$2"); then
2030                 fatal 1 "Could not determine the canonical location of $2"
2031             fi
2032             shift 2
2033             ;;
2034         --distro)
2035             DISTRO=$2
2036             shift 2
2037             ;;
2038         --reusebuild)
2039             if ! REUSEBUILD=$(canon_path "$2"); then
2040                 fatal 1 "Could not determine the canonical location of $2"
2041             fi
2042             shift 2
2043             ;;
2044         --norpm)
2045             NORPM=true
2046             shift
2047             ;;
2048         --noiokit)
2049             IOKITRPM=false
2050             shift
2051             ;;
2052         --patchless)
2053             PATCHLESS=true
2054             shift
2055             ;;
2056         --kernelrpm)
2057             if ! KERNELRPMSBASE=$(canon_path "$2"); then
2058                 fatal 1 "Could not determine the canonical location of $2"
2059             fi
2060             shift 2
2061             ;;
2062         --timestamp)
2063             TIMESTAMP=$2
2064             shift 2
2065             ;;
2066         --lustre)
2067             if ! LUSTRE=$(canon_filepath "$2"); then
2068                 fatal 1 "Could not determine the canonical location of $2"
2069             fi
2070             shift 2
2071             ;;
2072         --nodownload)
2073             DOWNLOAD=false
2074             shift 1
2075             ;;
2076         --nosrc)
2077             DO_SRC=false
2078             shift 1
2079             ;;
2080         --ofed-version)
2081             OFED_VERSION="$2"
2082             shift 2
2083             ;;
2084         --mpss-version)
2085             MPSS_VERSION="$2"
2086             shift 2
2087             ;;
2088         --publish)
2089             shift
2090             ;;
2091         --release)
2092             RELEASE=true
2093             shift
2094             ;;
2095         --src)
2096             DO_SRC=true
2097             shift 1
2098             ;;
2099         --stage)
2100             STAGEDIR=$2
2101             shift 2
2102             ;;
2103         --target)
2104             TARGET=$2
2105             shift 2
2106             ;;
2107         --target-archs)
2108             TARGET_ARCHS=$2
2109             shift 2
2110             ;;
2111         --xen)
2112             XEN=true
2113             shift
2114             ;;
2115         --set-value)
2116             eval $2
2117             shift 2
2118             ;;
2119         --)
2120             shift
2121             # there are actually some lustre configure flags that we need to
2122             # handle ourselves (but we still give them to configure)
2123             if [[ \ $@\  == *\ --disable-tests\ * ]]; then
2124                 LUSTRE_TESTS=false
2125             fi
2126             CONFIGURE_FLAGS=$@
2127             break
2128             ;;
2129         *)
2130             usage 1 "Unrecognized option: $1"
2131             ;;
2132     esac
2133 done
2134
2135 check_options
2136
2137 unpack_lustre
2138
2139 # XXX - should we _always_ get the buildid from the META file?  what are the
2140 # other (i.e. non-lustre-tarball use cases of lbuild)?
2141 BUILDID=$(sed -n -e 's/^BUILDID = //p' lustre/META)
2142
2143 load_target
2144
2145 if [ -n "$OFED_VERSION" -a "$OFED_VERSION" != "inkernel" ]; then
2146     download_ofed
2147     unpack_ofed || fatal 1 "Error unpacking OFED tarball"
2148 fi
2149
2150 if [ -n "$MPSS_VERSION" ]; then
2151     [ -z "$MPSS_DISTRO" ] && MPSS_DISTRO=$(autodetect_distro)
2152
2153     MPSS_INFO=$(mktemp -u mpss-info-XXXXXXXXXX.html)
2154     download_mpss_info "$MPSS_INFO"
2155
2156     if [ "$MPSS_VERSION" = "last" ]; then
2157         MPSS_VERSION=$(parse_mpss_info "$MPSS_INFO" "" ${MPSS_DISTRO})
2158         [ -z "$MPSS_VERSION" ] &&
2159             fatal 1 "Could not determine the last MPSS version"
2160     fi
2161
2162     download_mpss "$MPSS_INFO"
2163     [ -r "$MPSS_INFO" ] && rm -f "$MPSS_INFO"
2164     echo "Building with MPSS $MPSS_VERSION"
2165     unpack_mpss  || fatal 1 "Error unpacking MPSS tarballs"
2166     prepare_mpss || fatal 1 "Error preparing MPSS for kernel modules build"
2167
2168     if [ -z "$MPSS_OFED" ]; then
2169         MPSS_OFED=$(find $PWD -type f -path "*/ofed-driver-*/Module.symvers")
2170         if [ -n "$MPSS_OFED" ]; then
2171             MPSS_OFED="--with-o2ib=$(dirname $MPSS_OFED)"
2172         else
2173             MPSS_OFED="--without-o2ib"
2174         fi
2175     fi
2176
2177     # disable unsupported parts:
2178     PATCHLESS=true
2179     IOKITRPM=false
2180     LDISKFSRPM=false
2181     ZFSNOTSUPPORTED="yes"
2182
2183     # define variables for cross compilation:
2184     CROSS_SUFFIX="-mic"
2185     if [ "${MPSS_VERSION%%.*}" = "3" ]; then
2186         CC_TARGET_ARCH=k1om-mpss-linux
2187         LINUX="$TOPDIR/mpss"
2188         RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"cross_requires /bin/sh\""
2189     else
2190         CC_TARGET_ARCH=x86_64-k1om-linux
2191         LINUX="$TOPDIR/mpss/card/kernel"
2192         RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"cross_requires intel-mic-gpl = ${MPSS_VERSION%%-*}\""
2193     fi
2194     LUSTRE_VERSION=$(sed -n -e 's/^VERSION = //p' lustre/META)
2195     CONFIGURE_FLAGS="$CONFIGURE_FLAGS $MPSS_OFED --host=$CC_TARGET_ARCH --build=x86_64-pc-linux"
2196     RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"post_script build/gen_filelist.sh\""
2197     RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"make_args ARCH=k1om CROSS_COMPILE=${CC_TARGET_ARCH}-\""
2198     RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"cross_path ${CROSS_PATH:=/opt/lustre/${LUSTRE_VERSION}/${CC_TARGET_ARCH}}\""
2199     RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"rootdir %{cross_path}\""
2200     RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"_prefix %{cross_path}/usr\""
2201     RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"_mandir %{_prefix}/share/man\""
2202     RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"_sysconfdir %{cross_path}/etc\""
2203     RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"kmoddir extra\""
2204
2205     # redefine CC for proper ./configure during rpmbuild
2206     export CC=${CC_TARGET_ARCH}-gcc
2207 fi
2208
2209 # make sure the RPM build environment is set up
2210 create_rpmbuild_dirs
2211
2212 # if an unpacked kernel source tree was given on the command line
2213 # just build lustre with it (nothing distro kernel specific here)
2214 if [ -n "$LINUX" ]; then
2215     find_linux_release() {
2216         _find_linux_release $LINUX
2217     }
2218     build_ofed "${LINUXOBJ:-$LINUX}" "$OFED_VERSION" ||
2219         fatal 1 "error building OFED"
2220     build_lustre "$LINUX" "$LINUXOBJ"
2221 else
2222     if [ ! -f "${LBUILD_DIR}/lbuild-$DISTROMAJ" ]; then
2223         fatal 1 "${LBUILD_DIR}/lbuild-$DISTROMAJ not found"
2224     fi
2225     source ${LBUILD_DIR}/lbuild-$DISTROMAJ
2226     build_with_srpm || fatal 1 "Failed to build_with_srpm"
2227 fi
2228
2229 stage